<?php
/*##################################################
 *                      admin_blog_management.php
 *                            -------------------
 *   begin                : July 10, 2005
 *   copyright            : (C) 2005 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
####################################################
#                 Changelog                        #
#################################################### 
* 
*   Date                 : 16/03/2010
*   Auteur               : Swan | CsN
*   Email                : contact@chez-swan.net
*   Web                  : http://chez-swan.net/
*   Description          : modification du nom du module en module blog.
*
####################################################*/

require_once('../admin/admin_begin.php');
load_module_lang('blog'); //Chargement de la langue du module.
define('TITLE', $LANG['administration']);
require_once('../admin/admin_header.php');

//On recupre les variables.
$id = retrieve(GET, 'id', 0);
$idcat = retrieve(GET, 'idcat', 0);
$id_post = retrieve(POST, 'id', 0);
$del = !empty($_GET['delete']) ? true : false;

if ($del && !empty($id)) //Suppression de l'blog.
{    
	$Session->csrf_get_protect(); //Protection csrf
	
	//Visibilit de l'blog.
	$visible = $Sql->query("SELECT visible FROM " . PREFIX . "blog WHERE id = '" . $id . "'", __LINE__, __FILE__);	
	
	//On supprime dans la bdd.
	$Sql->query_inject("DELETE FROM " . PREFIX . "blog WHERE id = '" . $id . "'", __LINE__, __FILE__);	
	
	$Cache->load('blog');
	if (empty($idcat))//Racine.
	{
		$CAT_BLOG[0]['id_left'] = 0;
		$CAT_BLOG[0]['id_right'] = 0;
	}
	
	//Mise  jours du nombre d'blog des parents.
	$clause_update = ($visible == '1') ? 'nbr_blog_visible = nbr_blog_visible - 1' : 'nbr_blog_unvisible = nbr_blog_unvisible - 1';
	$Sql->query_inject("UPDATE " . PREFIX . "blog_cats SET " . $clause_update . " WHERE id_left <= '" . $CAT_BLOG[$idcat]['id_left'] . "' AND id_right >= '" . $CAT_BLOG[$idcat]['id_right'] . "'", __LINE__, __FILE__);
	
	//On supprimes les ventuels commentaires associs.
	$Sql->query_inject("DELETE FROM " . DB_TABLE_COM . " WHERE idprov = " . $id . " AND script = 'blog'", __LINE__, __FILE__);
	
	// Feeds Regeneration
    import('content/syndication/feed');
    Feed::clear_cache('blog');
    
	redirect(HOST . SCRIPT);
}	
elseif (!empty($id))
{
	$Template->set_filenames(array(
		'admin_blog_management'=> 'blog/admin_blog_management.tpl'
	));

	$blog = $Sql->query_array(PREFIX . 'blog', '*', "WHERE id = '" . $id . "'", __LINE__, __FILE__);	

	$Template->assign_vars(array(	
		'KERNEL_EDITOR' => display_editor(),
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_REQUIRE_TEXT' => $LANG['require_text'],
		'L_REQUIRE_CAT' => $LANG['require_cat'],
		'L_BLOG_MANAGEMENT' => $LANG['blog_management'],
		'L_BLOG_ADD' => $LANG['blog_add'],
		'L_BLOG_CAT' => $LANG['cat_management'],
		'L_BLOG_CONFIG' => $LANG['blog_config'],
		'L_BLOG_CAT_ADD' => $LANG['blog_cats_add'],
		'L_EDIT_BLOG' => $LANG['edit_blog'],
		'L_REQUIRE' => $LANG['require'],
		'L_PAGE_PROMPT' => $LANG['page_prompt'],
		'L_CATEGORY' => $LANG['category'],
		'L_TITLE' => $LANG['title'],
		'L_BLOG_ICON' => $LANG['blog_icon'],
		'L_OR_DIRECT_PATH' => $LANG['or_direct_path'],
		'L_VIEWS' => $LANG['views'],
		'L_YES' => $LANG['yes'],
		'L_NO' => $LANG['no'],
		'L_BLOG_DATE' => $LANG['blog_date'],
		'L_RELEASE_DATE' => $LANG['release_date'],
		'L_IMMEDIATE' => $LANG['immediate'],
		'L_UNAPROB' => $LANG['unaprob'],
		'L_UNTIL' => $LANG['until'],
		'L_TEXT' => $LANG['content'],
		'L_EXPLAIN_PAGE' => $LANG['explain_page'],
		'L_PREVIEW' => $LANG['preview'],
		'L_UPDATE' => $LANG['update'],
		'L_RESET' => $LANG['reset']
	));
		
	//Catgories.
	$categories = '<option value="0">' . $LANG['root'] . '</option>';
	$result = $Sql->query_while("SELECT id, level, name 
	FROM " . PREFIX . "blog_cats
	ORDER BY id_left", __LINE__, __FILE__);
	while ($row = $Sql->fetch_assoc($result))
	{
		$margin = ($row['level'] > 0) ? str_repeat('--------', $row['level']) : '--';
		$selected = ($row['id'] == $blog['idcat']) ? 'selected="selected"' : '';
		$categories .= '<option value="' . $row['id'] . '" ' . $selected . '>' . $margin . ' ' . $row['name'] . '</option>';
	}
	$Sql->query_close($result);
	
	//Images disponibles
	$img_direct_path = (strpos($blog['icon'], '/') !== false);
	$rep = './';
	$image_list = '<option value=""' . ($img_direct_path ? ' selected="selected"' : '') . '>--</option>';
	if (is_dir($rep)) //Si le dossier existe
	{
		$img_array = array();
		$dh = @opendir( $rep);
		while (! is_bool($lang = readdir($dh)))
		{
			if (preg_match('`\.(gif|png|jpg|jpeg|tiff)+$`i', $lang))
				$img_array[] = $lang; //On cre un tableau, avec les different fichiers.
		}
		closedir($dh); //On ferme le dossier

		foreach ($img_array as $key => $img_path)
		{	
			$selected = $img_path == $blog['icon'] ? ' selected="selected"' : '';
			$image_list .= '<option value="' . $img_path . '"' . ($img_direct_path ? '' : $selected) . '>' . $img_path . '</option>';
		}
	}

	$Template->assign_block_vars('blog', array(
		'TITLE' => $blog['title'],
		'IMG_ICON' => !empty($blog['icon']) ? '<img src="' . $blog['icon'] . '" alt="" class="valign_middle" />' : '',
		'IMG_LIST' => $image_list,
		'IMG_PATH' => $img_direct_path ? $blog['icon'] : '',
		'IDBLOG' => $blog['id'],
		'USER_ID' => $blog['user_id'],
		'CATEGORIES' => $categories,
		'CONTENTS' => unparse($blog['contents']),
		'CURRENT_DATE' => gmdate_format('date_format_short', $blog['timestamp']),
		'DAY_RELEASE_S' => !empty($blog['start']) ? gmdate_format('d', $blog['start']) : '',
		'MONTH_RELEASE_S' => !empty($blog['start']) ? gmdate_format('m', $blog['start']) : '',
		'YEAR_RELEASE_S' => !empty($blog['start']) ? gmdate_format('Y', $blog['start']) : '',
		'DAY_RELEASE_E' => !empty($blog['end']) ? gmdate_format('d', $blog['end']) : '',
		'MONTH_RELEASE_E' => !empty($blog['end']) ? gmdate_format('m', $blog['end']) : '',
		'YEAR_RELEASE_E' => !empty($blog['end']) ? gmdate_format('Y', $blog['end']) : '',
		'DAY_DATE' => !empty($blog['timestamp']) ? gmdate_format('d', $blog['timestamp']) : '',
		'MONTH_DATE' => !empty($blog['timestamp']) ? gmdate_format('m', $blog['timestamp']) : '',
		'YEAR_DATE' => !empty($blog['timestamp']) ? gmdate_format('Y', $blog['timestamp']) : '',
		'USER_ID' => $blog['user_id'],
		'VISIBLE_WAITING' => (($blog['visible'] == 2 || !empty($blog['end'])) ? 'checked="checked"' : ''),
		'VISIBLE_ENABLED' => (($blog['visible'] == 1 && empty($blog['end'])) ? 'checked="checked"' : ''),
		'VISIBLE_UNAPROB' => (($blog['visible'] == 0) ? 'checked="checked"' : ''),
		'START' => ((!empty($blog['start'])) ? gmdate_format('date_format_short', $blog['start']) : ''),
		'END' => ((!empty($blog['end'])) ? gmdate_format('date_format_short', $blog['end']) : ''),
		'HOUR' => gmdate_format('H', $blog['timestamp']),
		'MIN' => gmdate_format('i', $blog['timestamp']),
		'DATE' => gmdate_format('date_format_short', $blog['timestamp'])	
	));
	
	//Gestion erreur.
	$get_error = retrieve(GET, 'error', '');
	if ($get_error == 'incomplete')
		$Errorh->handler($LANG['e_incomplete'], E_USER_NOTICE);
	
	$Template->pparse('admin_blog_management'); 
}	
elseif (!empty($_POST['previs']) && !empty($id_post))
{
	$Template->set_filenames(array(
		'admin_blog_management'=> 'blog/admin_blog_management.tpl'
	));

	$title = retrieve(POST, 'title', '', TSTRING_UNCHANGE);
	$icon = retrieve(POST, 'icon', '', TSTRING_UNCHANGE);
	$icon_path = retrieve(POST, 'icon_path', '', TSTRING_UNCHANGE);
	$compt = retrieve(POST, 'views', 0);
	$contents = retrieve(POST, 'contents', '', TSTRING_AS_RECEIVED);
	$contents_preview = retrieve(POST, 'contents', '', TSTRING_UNCHANGE);
	$user_id = retrieve(POST, 'user_id', 0);
	$idcat = retrieve(POST, 'idcat', 0);
	$current_date = retrieve(POST, 'current_date', '', TSTRING_UNCHANGE);
	$start = retrieve(POST, 'start', '', TSTRING_UNCHANGE);
	$end = retrieve(POST, 'end', '', TSTRING_UNCHANGE);
	$hour = retrieve(POST, 'hour', '', TSTRING_UNCHANGE);
	$min = retrieve(POST, 'min', '', TSTRING_UNCHANGE);	
	$get_visible = retrieve(POST, 'visible', 0);
	$start_timestamp = strtotimestamp($start, $LANG['date_format_short']);
	$end_timestamp = strtotimestamp($end, $LANG['date_format_short']);
	$current_date_timestamp = strtotimestamp($current_date, $LANG['date_format_short']);
	
	if (!empty($icon_path))
		$icon = $icon_path;	
	
    $visible = 0;
	switch ($get_visible)
	{
        case 1:
            $visible = 1;
            break;
        case 2:
    		if ($start_timestamp > time())
    			$visible = 2;
    		else
    			$start = '';
    	
    		if ($end_timestamp > time() && $end_timestamp > $start_timestamp)
    			$visible = 2;
    		else
    			$end = '';
            break;
        default:
            break;
	}
	
	//Catgories.	
	$i = 0;	
	$categories = '<option value="0">' . $LANG['root'] . '</option>';
	$result = $Sql->query_while("SELECT id, level, name 
	FROM " . PREFIX . "blog_cats
	ORDER BY id_left", __LINE__, __FILE__);
	while ($row = $Sql->fetch_assoc($result))
	{
		$margin = ($row['level'] > 0) ? str_repeat('--------', $row['level']) : '--';
		$selected = ($row['id'] == $idcat) ? 'selected="selected"' : '';
		$categories .= '<option value="' . $row['id'] . '" ' . $selected . '>' . $margin . ' ' . $row['name'] . '</option>';
		$i++;
	}
	$Sql->query_close($result);
	
	//Images disponibles
	$img_direct_path = (strpos($icon, '/') !== false);
	$rep = './';
	$image_list = '<option value=""' . ($img_direct_path ? ' selected="selected"' : '') . '>--</option>';
	if (is_dir($rep)) //Si le dossier existe
	{
		$img_array = array();
		$dh = @opendir( $rep);
		while (! is_bool($lang = readdir($dh)))
		{	
			if (preg_match('`\.(gif|png|jpg|jpeg|tiff)+$`i', $lang))
				$img_array[] = $lang; //On cre un tableau, avec les different fichiers.
		}
		closedir($dh); //On ferme le dossier

		foreach ($img_array as $key => $img_path)
		{
			$selected = $img_path == $icon ? ' selected="selected"' : '';
			$image_list .= '<option value="' . $img_path . '"' . ($img_direct_path ? '' : $selected) . '>' . $img_path . '</option>';
		}
	}
	
	$Template->assign_block_vars('blog', array(
		'IDBLOG' => $id_post,
		'TITLE' => $title,
		'CATEGORIES' => $categories,
		'IMG_PATH' => $img_direct_path ? $icon : '',
		'IMG_ICON' => !empty($icon) ? '<img src="' . $icon . '" alt="" class="valign_middle" />' : '',
		'IMG_LIST' => $image_list,
		'CONTENTS' => $contents_preview,
		'USER_ID' => $user_id,
		'CURRENT_DATE' => $current_date,
		'START' => ((!empty($start) && $visible == 2) ? $start : ''),
		'END' => ((!empty($end) && $visible == 2) ? $end : ''),
		'HOUR' => $hour,
		'MIN' => $min,
		'DAY_RELEASE_S' => !empty($start_timestamp) ? gmdate_format('d', $start_timestamp) : '',
		'MONTH_RELEASE_S' => !empty($start_timestamp) ? gmdate_format('m', $start_timestamp) : '',
		'YEAR_RELEASE_S' => !empty($start_timestamp) ? gmdate_format('Y', $start_timestamp) : '',
		'DAY_RELEASE_E' => !empty($end_timestamp) ? gmdate_format('d', $end_timestamp) : '',
		'MONTH_RELEASE_E' => !empty($end_timestamp) ? gmdate_format('m', $end_timestamp) : '',
		'YEAR_RELEASE_E' => !empty($end_timestamp) ? gmdate_format('Y', $end_timestamp) : '',
		'DAY_DATE' => !empty($current_date_timestamp) ? gmdate_format('d', $current_date_timestamp) : '',
		'MONTH_DATE' => !empty($current_date_timestamp) ? gmdate_format('m', $current_date_timestamp) : '',
		'YEAR_DATE' => !empty($current_date_timestamp) ? gmdate_format('Y', $current_date_timestamp) : '',
		'VISIBLE_WAITING' => (($visible == 2) ? 'checked="checked"' : ''),
		'VISIBLE_ENABLED' => (($visible == 1) ? 'checked="checked"' : ''),
		'VISIBLE_UNAPROB' => (($visible == 0) ? 'checked="checked"' : '')
	));
	
	$pseudo = $Sql->query("SELECT login FROM " . DB_TABLE_MEMBER . " WHERE user_id = '" . $user_id . "'", __LINE__, __FILE__);
	$Template->assign_block_vars('blog.preview', array(
		'USER_ID' => $user_id,
		'TITLE' => $title,
		'CONTENTS' => second_parse(stripslashes(strparse($contents))),
		'PSEUDO' => $pseudo,
		'DATE' => gmdate_format('date_format_short')
	));
	
	$Template->assign_vars(array(	
		'KERNEL_EDITOR' => display_editor(),
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_REQUIRE_TEXT' => $LANG['require_text'],
		'L_REQUIRE_CAT' => $LANG['require_cat'],
		'L_BLOG_MANAGEMENT' => $LANG['blog_management'],
		'L_BLOG_ADD' => $LANG['blog_add'],
		'L_BLOG_CAT' => $LANG['cat_management'],
		'L_BLOG_CONFIG' => $LANG['blog_config'],
		'L_BLOG_CAT_ADD' => $LANG['blog_cats_add'],
		'L_PREVIEW' => $LANG['preview'],
		'L_COM' => $LANG['com'],
		'L_WRITTEN_BY' => $LANG['written_by'],
		'L_ON' => $LANG['on'],
		'L_EDIT_BLOG' => $LANG['edit_blog'],
		'L_REQUIRE' => $LANG['require'],
		'L_PAGE_PROMPT' => $LANG['page_prompt'],
		'L_CATEGORY' => $LANG['category'],
		'L_TITLE' => $LANG['title'],
		'L_BLOG_ICON' => $LANG['blog_icon'],
		'L_OR_DIRECT_PATH' => $LANG['or_direct_path'],
		'L_VIEWS' => $LANG['views'],
		'L_YES' => $LANG['yes'],
		'L_NO' => $LANG['no'],
		'L_BLOG_DATE' => $LANG['blog_date'],
		'L_RELEASE_DATE' => $LANG['release_date'],
		'L_IMMEDIATE' => $LANG['immediate'],
		'L_UNAPROB' => $LANG['unaprob'],
		'L_UNTIL' => $LANG['until'],
		'L_TEXT' => $LANG['content'],
		'L_EXPLAIN_PAGE' => $LANG['explain_page'],
		'L_UPDATE' => $LANG['update'],
		'L_RESET' => $LANG['reset']
	));
	
	$Template->pparse('admin_blog_management'); 
}
elseif (!empty($_POST['valid']) && !empty($id_post)) //inject
{
	$title = retrieve(POST, 'title', '');
	$icon = retrieve(POST, 'icon', '');
	$icon_path = retrieve(POST, 'icon_path', '');
	$contents = retrieve(POST, 'contents', '', TSTRING_PARSE);
	$idcat = retrieve(POST, 'idcat', 0);
	$current_date = retrieve(POST, 'current_date', '', TSTRING_UNCHANGE);
	$start = retrieve(POST, 'start', '', TSTRING_UNCHANGE);
	$end = retrieve(POST, 'end', '', TSTRING_UNCHANGE);
	$hour = retrieve(POST, 'hour', '', TSTRING_UNCHANGE);
	$min = retrieve(POST, 'min', '', TSTRING_UNCHANGE);	
	$get_visible = retrieve(POST, 'visible', 0);
	
	if (!empty($icon_path))
		$icon = $icon_path;
			
	//On met  jour la config de base du sondage
	if (!empty($title) && !empty($contents))
	{
		$start_timestamp = strtotimestamp($start, $LANG['date_format_short']);
		$end_timestamp = strtotimestamp($end, $LANG['date_format_short']);
		
		$visible = 1;		
		if ($get_visible == 2)
		{	
			if ($start_timestamp > time())
				$visible = 2;
			elseif ($start_timestamp == 0)
				$visible = 1;
			else //Date infrieur  celle courante => inutile.
				$start_timestamp = 0;

			if ($end_timestamp > time() && $end_timestamp > $start_timestamp && $start_timestamp != 0)
				$visible = 2;
			elseif ($start_timestamp != 0) //Date infrieur  celle courante => inutile.
				$end_timestamp = 0;
		}
		elseif ($get_visible == 1)
		{	
			$start_timestamp = 0;
			$end_timestamp = 0;
		}
		else
		{	
			$visible = 0;
			$start_timestamp = 0;
			$end_timestamp = 0;
		}
		
		$timestamp = strtotimestamp($current_date, $LANG['date_format_short']);
		if ($timestamp > 0)
			//Ajout des heures et minutes
			$timestamp += ($hour * 3600) + ($min * 60);
		else
			$timestamp = time();
		
		$cat_clause = ' ';
		//Changement de catgorie parente?
		$blog_info = $Sql->query_array(PREFIX . "blog", "id", "idcat", "visible", "WHERE id = '" . $id_post . "'", __LINE__, __FILE__);		
		if ($blog_info['idcat'] != $idcat && !empty($blog_info['id']))
		{
			if ($blog_info['visible'] == 1)
				$is_visible = 'nbr_blog_visible';
			else
				$is_visible = 'nbr_blog_unvisible';
			$Sql->query_inject("UPDATE " . PREFIX . "blog_cats SET " . $is_visible . " = " . $is_visible . " - 1 WHERE id = '" . $blog_info['idcat'] . "'", __LINE__, __FILE__);
			$Sql->query_inject("UPDATE " . PREFIX . "blog_cats SET " . $is_visible . " = " . $is_visible . " + 1 WHERE id = '" . $idcat . "'", __LINE__, __FILE__);
			$cat_clause = " idcat = '" . $idcat . "', ";
		}
		
		$Sql->query_inject("UPDATE " . PREFIX . "blog SET" . $cat_clause . "title = '" . $title . "', contents = '" . str_replace('[page][/page]', '', $contents) . "', icon = '" . $icon . "', visible = '" . $visible . "', start = '" .  $start_timestamp . "', end = '" . $end_timestamp . "', timestamp = '" . $timestamp . "' WHERE id = '" . $id_post . "'", __LINE__, __FILE__);
		
		// Feeds Regeneration
        import('content/syndication/feed');
        Feed::clear_cache('blog');
		
		redirect(HOST . SCRIPT);
	}
	else
		redirect(HOST . DIR . '/blog/admin_blog.php?id= ' . $id_post . '&error=incomplete#errorh');
}		
else
{
	$Template->set_filenames(array(
		'admin_blog_management'=> 'blog/admin_blog_management.tpl'
	));
	
	$nbr_blog = $Sql->count_table('blog', __LINE__, __FILE__);
	
	//On cre une pagination si le nombre d'blog est trop important.
	import('util/pagination');
	$Pagination = new Pagination();
	
	$Template->assign_vars(array(
		'THEME' => get_utheme(),
		'LANG' => get_ulang(),
		'PAGINATION' => $Pagination->display('admin_blog.php?p=%d', $nbr_blog, 'p', 25, 3),
		'CHEMIN' => SCRIPT,
		'L_CONFIRM_DEL_BLOG' => $LANG['confirm_del_blog'],
		'L_BLOG_MANAGEMENT' => $LANG['blog_management'],
		'L_BLOG_ADD' => $LANG['blog_add'],
		'L_BLOG_CAT' => $LANG['cat_management'],
		'L_BLOG_CONFIG' => $LANG['blog_config'],
		'L_BLOG_CAT_ADD' => $LANG['blog_cats_add'],
		'L_NAME' => $LANG['name'],
		'L_TITLE' => $LANG['title'],
		'L_CATEGORY' => $LANG['category'],
		'L_PSEUDO' => $LANG['pseudo'],
		'L_DATE' => $LANG['date'],
		'L_APROB' => $LANG['aprob'],
		'L_UPDATE' => $LANG['update'],
		'L_DELETE' => $LANG['delete'],
		'L_SHOW' => $LANG['show']
	));

	$Template->assign_block_vars('list', array(
	));
	
	$result = $Sql->query_while("SELECT a.id, a.idcat, a.title, a.timestamp, a.visible, a.start, a.end, ac.name, m.login 
	FROM " . PREFIX . "blog a
	LEFT JOIN " . PREFIX . "blog_cats ac ON ac.id = a.idcat
	LEFT JOIN " . DB_TABLE_MEMBER . " m ON a.user_id = m.user_id
	ORDER BY a.timestamp DESC " .
	$Sql->limit($Pagination->get_first_msg(25, 'p'), 25), __LINE__, __FILE__);
	while ($row = $Sql->fetch_assoc($result))
	{
		if ($row['visible'] == 2)
			$aprob = $LANG['waiting'];
		elseif ($row['visible'] == 1)
			$aprob = $LANG['yes'];
		else
			$aprob = $LANG['no'];

		//On reccourci le lien si il est trop long pour viter de dformer l'administration.
		$title = strlen($row['title']) > 45 ? substr_html($row['title'], 0, 45) . '...' : $row['title'];

		$visible = '';
		if ($row['start'] > 0)
			$visible .= gmdate_format('date_format_short', $row['start']);
		if ($row['end'] > 0 && $row['start'] > 0)
			$visible .= ' ' . strtolower($LANG['until']) . ' ' . gmdate_format('date_format_short', $row['end']);
		elseif ($row['end'] > 0)
			$visible .= $LANG['until'] . ' ' . gmdate_format('date_format_short', $row['end']);
		
		$Template->assign_block_vars('list.blog', array(
			'TITLE' => $title,
			'IDCAT' => $row['idcat'],
			'ID' => $row['id'],
			'PSEUDO' => !empty($row['login']) ? $row['login'] : $LANG['guest'],
			'DATE' => gmdate_format('date_format_short', $row['timestamp']),
			'APROBATION' => $aprob,
			'VISIBLE' => ((!empty($visible)) ? '(' . $visible . ')' : ''),
			'U_CAT' => '<a href="../blog/blog' . url('.php?cat=' . $row['idcat'], '-' . $row['idcat'] . '.php') . '">' . (!empty($row['idcat']) ? $row['name'] : '<em>' . $LANG['root'] . '</em>') . '</a>'
		));
	}
	$Sql->query_close($result);
	
	$Template->pparse('admin_blog_management');
}

require_once('../admin/admin_footer.php');

?>